;Ŀ
;                 Joe Forster/STA                 
;                                                 
;                     DWI.ASM                     
;                                                 
;             DOOM WAD file installer             
;

CSeg		segment
		assume	cs:CSeg, ds:CSeg, ss:CSeg
		org	0100h

Main:		mov	di, Offset DataStart
		mov	cx, DataEnd - DataStart
		xor	al, al
		cld
		rep	stosb
		mov	dx, Offset Hello
		mov	ah, 9
		int	21h
		mov	bl, 1
		mov	di, Offset Parameter
		mov	cx, 79
		call	ParamStr
		or	bh, bh
		je	@01
		mov	si, Offset Parameter
		call	StrLen
		add	si, ax
		dec	si
		lodsb
		cmp	al, '\'
		je	@01
		mov	ax, '\'
		mov	[si], ax
@01:		mov	di, Offset SearchPar
		mov	si, Offset Parameter
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset WadFiles
		stc
		call	StrCopy
		mov	di, Offset Line
		mov	dx, Offset SearchPar
		mov	cx, 27h
		mov	ah, 4Eh
		int	21h
		jnc	@04
		jmp	@02
@04:		push	di
		mov	si, Offset Parameter
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, 009Eh
		stc
		call	StrCopy
		pop	di
		mov	dx, Offset SearchPar
		mov	ax, 3D00h
		int	21h
		jc	@05
		mov	bx, ax
		xor	ax, ax
		mov	word ptr Sign[0], ax
		mov	word ptr Sign[2], ax
		mov	dx, Offset Sign
		mov	cx, 4
		mov	ah, 3Fh
		int	21h
		mov	ah, 3Eh
		int	21h
		cmp	word ptr Sign[0], 'WP'
		jne	@05
		cmp	word ptr Sign[2], 'DA'
		jne	@05
		cmp	di, Offset Line
		jne	@06
		mov	si, Offset File
		mov	cx, 5
		clc
		call	StrCopy
@06:		mov	al, ' '
		stosb
		mov	si, 009Eh
		mov	cx, 12
		clc
		call	LowerCase
@05:		mov	ah, 4Fh
		int	21h
		jnc	@04
		push	di
		mov	si, Offset Parameter
		mov	di, Offset SearchPar
		mov	cx, 79
		clc
		call	StrCopy
		mov	si, Offset Config
		stc
		call	StrCopy
		pop	di
		mov	dx, Offset SearchPar
		cmp	di, Offset Line
		jne	@07
		mov	ah, 41h
		int	21h
		jmp	@02
@07:		mov	ax, 0A0Dh
		stosw
		xor	cx, cx
		mov	ah, 3Ch
		int	21h
		jc	@02
		mov	dx, Offset Line
		mov	cx, di
		sub	cx, dx
		mov	bx, ax
		mov	ah, 40h
		int	21h
		mov	ah, 3Eh
		int	21h
@02:		mov	ax, 4C00h
		int	21h

StrCopy:	mov	dx, cx
StrPartCopy:	cld
		pushf
		or	di, di
		jne	@04_StrCopy
		popf
		retn
@04_StrCopy:	or	cx, cx
		je	@01_StrCopy
@02_StrCopy:	or	dx, dx
		je	@01_StrCopy
		lodsb
		or	al, al
		je	@01_StrCopy
		stosb
		dec	dx
		loop	@02_StrCopy
@01_StrCopy:	xor	al, al
		popf
		jnc	@03_StrCopy
		stosb
@03_StrCopy:	retn

LowerCase:	mov	dx, cx
		cld
		pushf
		or	di, di
		jne	@04_LowerCase
		popf
		retn
@04_LowerCase:	or	cx, cx
		je	@01_LowerCase
@02_LowerCase:	or	dx, dx
		je	@01_LowerCase
		lodsb
		or	al, al
		je	@01_LowerCase
		call	LoCase
		stosb
		dec	dx
		loop	@02_LowerCase
@01_LowerCase:	xor	al, al
		popf
		jnc	@03_LowerCase
		stosb
@03_LowerCase:	retn

StrLen:		cld
		push	si
		xor	ah, ah
@02_StrLen:	lodsb
		or	al, al
		je	@01_StrLen
		inc	ah
		or	ah, ah
		jne	@02_StrLen
@01_StrLen:	pop	si
		mov	al, ah
		xor	ah, ah
		retn

ParamStr:	mov	si, 0081h
		xor	bh, bh
@01_ParamStr:	lodsb
		cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		inc	bh
		cmp	bl, bh
		je	@03_ParamStr
@04_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@01_ParamStr
		cmp	al, 9
		je	@01_ParamStr
		lodsb
		jmp	@04_ParamStr
@03_ParamStr:	or	di, di
		je	@05_ParamStr
@06_ParamStr:	cmp	al, 13
		je	@02_ParamStr
		cmp	al, ' '
		je	@02_ParamStr
		cmp	al, 9
		je	@02_ParamStr
		call	UpCase
		stosb
		lodsb
		loop	@06_ParamStr
@02_ParamStr:	xor	al, al
		stosb
@05_ParamStr:	retn

LoCase:		cmp	al, 'A'
		jb	@01_LoCase
		cmp	al, 'Z'
		ja	@01_LoCase
		add	al, 'a' - 'A'
@01_Locase:	retn

UpCase:		cmp	al, 'a'
		jb	@01_UpCase
		cmp	al, 'z'
		ja	@01_UpCase
		sub	al, 'a' - 'A'
@01_Upcase:	retn

Hello		db	'DOOM WAD file installer by Joe Forster/STA', 13, 10, '$'
File		db	'-file', 0
WadFiles	db	'*.WAD', 0
Config		db	'WADFILES.CFG', 0

DataStart:

Sign		dd	?
Line		db	255 + 1 dup (?)
Parameter	db	79 + 1 dup (?)
SearchPar	db	79 + 1 dup (?)

DataEnd:

CSeg		ends

		end	Main
